<template>
  <div class="sidebar">
    <div class="sidebar__top">
      <div class="sidebar__logo">
        <nuxt-link :to="localePath('/')">
          <svg-icon name="logotype-small" />
        </nuxt-link>
      </div>
      <nav class="sidebar__nav">
        <slot />
      </nav>
    </div>
    <div class="sidebar__bottom">
      <div class="sidebar__logout" @click="logout">
        <span>
          {{ $t('profile.menu.logout') }}
        </span>
        <svg-icon name="logout" />
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, useContext, computed } from '@nuxtjs/composition-api'
import { Role } from '~/types'

export default defineComponent({
  name: 'Sidebar',
  setup() {
    const {
      app: { $api, $accessor }
    } = useContext()

    const isAdministrator = computed(() =>
      $accessor.auth.withRole(Role.Administrator)
    )

    function logout() {
      $api.auth.logout()
    }

    return { logout, isAdministrator }
  }
})
</script>

<style lang="scss" scoped>
.sidebar {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  position: sticky;
  top: 0px;
  bottom: 0px;
  left: 90px;
  padding: 60px 10px 60px 0;
  overflow-y: auto;

  &::-webkit-scrollbar {
    width: 4px;
    height: 4px;
  }
  &::-webkit-scrollbar-track {
    background-color: transparent;
  }
  &::-webkit-scrollbar-thumb {
    background: #00ffb3;
    -webkit-border-radius: 3px;
    border-radius: 3px;
  }

  &__top {
    flex: 1;
    padding-bottom: 40px;
  }
  &__logo {
    margin-bottom: 35px;
    svg {
      width: 65px;
      height: 65px;
      fill: #3f4a6e;
    }
  }
  &__logout {
    cursor: pointer;
    display: inline-flex;
    align-items: center;
    font-size: 0px;
    span {
      font-size: 24px;
      line-height: 33px;
      letter-spacing: 0px;
      color: #8591ad;
    }
    svg {
      margin-left: 20px;
      width: 20px;
      height: 20px;
      fill: #8591ad;
    }
  }

  &__nav {
    ul {
      margin: 0px;
      padding: 0px;
      list-style: none;
      li {
        margin-bottom: 5px;
        &:last-child {
          margin-bottom: 0px;
        }
        a {
          font-size: 30px;
          line-height: 45px;
          letter-spacing: 0px;
          color: #8591ad;
          &.is-active,
        //&.nuxt-link-active:not(:first-child),
        &.nuxt-link-active,
        &:hover {
            color: #fff;
          }
        }

        &.divider {
          margin-top: 21px;
          padding-top: 15px;
          position: relative;
          &::after {
            display: block;
            content: '';
            position: absolute;
            top: 0;
            left: 0;
            height: 1px;
            width: 220px;
            background: #8591ad;
            max-width: 100%;
          }
        }
      }
    }
  }
}
</style>
